/*
	Zonic System V0.21 alpha
	
	1996 by Tinic Urou. The alpha versions are FREEWARE.
	
 _________________________________________________________	
|	Base class for layout and eventhandling
|_________________________________________________________
*/
#ifndef ZGROUP
#define ZGROUP
#include "zonic.h"
#include "zwindow.h"

#define ZGROUP_VERSION				23

#define	ZGroupObject				new ZGroup

#define	ZGroup_Child					(0xF100)
#define ZGroup_Type						(0xF101)
#define 	ZGroup_Type_Horizontal		(0x0000)
#define		ZGroup_Type_Vertical		(0x0001)
#define ZGroup_Background				(0xF102)
#define ZGroup_Frame					(0xF103)
#define		ZGroup_Frame_None			(0x0000)
#define		ZGroup_Frame_Standard		(0x0001)
#define		ZGroup_Frame_Button			(0x0002)
#define		ZGroup_Frame_Group			(0x0003)
#define 	ZGroup_Frame_Root			(0x0004)
#define 	ZGroup_Frame_Double			(0x0005)
#define ZGroup_HWeight					(0xF104)
#define ZGroup_VWeight					(0xF105)
#define ZGroup_State					(0xF106)
#define 	ZGroup_State_Normal			(0x0000)
#define 	ZGroup_State_Selected		(0x0001)
#define 	ZGroup_State_Disabled		(0x0002)
#define		ZGroup_State_Hidden			(0x0003)
#define ZGroup_FrameState				(0xF107)
#define 	ZGroup_FrameState_Normal	(0x0000)
#define 	ZGroup_FrameState_Selected	(0x0001)
#define ZGroup_Align					(0xF108)
#define 	ZGroup_Align_Center			(0x0000)
#define 	ZGroup_Align_Left			(0x0001)
#define 	ZGroup_Align_Right			(0x0002)
#define 	ZGroup_Align_Top			(0x0001)
#define 	ZGroup_Align_Bottom			(0x0002)
#define ZGroup_DragMessage				(0xF109)
#define ZGroup_Label					(0xF10A)
#define ZGroup_MinHeight				(0xF10B)
#define ZGroup_MinWidth					(0xF10C)
#define ZGroup_MaxHeight				(0xF10D)
#define	ZGroup_MaxWidth					(0xF10E)
#define ZGroup_Space					(0xF10F)
#define ZGroup_Colums					(0xF110)
#define ZGroup_Rows						(0xF110)
#define ZGroup_Folded					(0xF111)
#define ZGroup_MessageHandler			(0xF112)
#define ZGroup_Target					(0xF113)
#define ZGroup_CanBeDropped				(0xF114)
#define ZGroup_ID						(0xF115)
#define ZGroup_BorderUp					(0xF116)
#define ZGroup_BorderDown				(0xF117)
#define ZGroup_BorderLeft				(0xF118)
#define ZGroup_BorderRight				(0xF119)

#define	Child							ZGroup_Child
#define Space							Child,HGroupObject(End)

#define PEN_DARK						0x00
#define PEN_HALFDARK					0x01
#define PEN_BACKGROUND					0x02
#define PEN_HALFSHINE					0x03
#define PEN_SHINE						0x04
#define PEN_MARK						0x05
#define PEN_UNMARK						0x06
#define PEN_ROOT						0x07
#define PEN_MID							0x08
#define PEN_HIGH						0x09

#define Z_DRAG_SOURCE					"ZGroup Source"
#define Z_DRAG_DEST						"ZGroup Destination"
#define Z_DRAG_STATE					"ZGroup DragState"
#define Z_DRAG_DROPPED					'zdrp'
#define Z_DRAG_ENTERED					'zdre'
#define Z_DRAG_INSIDE					'zdri'
#define Z_DRAG_LEAVED					'zdrl'

#pragma export on

extern 	rgb_color ZPens[];

class ZGroup
{
	public:
					ZGroup(TAG_ARG);
					ZGroup(struct TagItem *tags);
					~ZGroup();
// Eventhandling
					
	virtual	ZGroup	*zKeyDown(ulong aKey);			
	virtual bool	zMouseDown(BPoint pos);			
	virtual void	zMessageReceived(BMessage *msg);
	virtual	bool 	zMessageFilter(BMessage *msg);

 	virtual void	zFocusKeyDown(ulong aKey);
			bool	zPostMessage(BMessage *msg);

// Rendering

	virtual	void	zDraw(BRect rect);
			void 	zDrawBackground(BRect rect, char pen);
			void	zFillRect(BRect rect, char pen);
			void	zStrokeRect(BRect rect, char pen);

// Configstuff and Setup, most also setable with tags while construction

			void	zSetState(char state);
			void	zSetAlign(char align);
			void	zSetDragMessage(BMessage *msg);
			void 	zSetPen(char pen);
			void 	zSetWindrose(ZGroup *up, ZGroup *down, ZGroup *left, ZGroup *right);	
			BPoint	zSetMaxSize(BPoint dim);
			BPoint	zSetMinSize(BPoint dim);
			void	zSetBorder(BRect rect);
			void	zSetFrameType(char type);
			void	zSetType(char type);
			void	zSetTagMinSize(BPoint rect);
			void	zSetTagMaxSize(BPoint rect);
			void	zSetFocus(bool state);
			void 	zSetColor(char pen);
			void 	zSetLowColor(char pen);
			void	zSetDrawMode(long mode);
			void	zSetTarget(ZGroup *c);
			void	zSetID(char *id);
			void	zSetSpace(float s);
			void	zSetFrameState(char state);
	
			BPoint	zMinSize();
			BPoint	zMaxSize();
			BPoint	zTagMinSize();
			BPoint	zTagMaxSize();
			char	zType();
			char	zFrameType();
			BRect	zBorder();		
			bool	zIsFocus();
			char	zState();
			char	zBackground();
			ZGroup	*zTarget();
			ZGroup  *zWindrose(int i);
			char	*zID();
			float	zSpace();
			char	zFrameState();
			void	zFoldGroup();
			void	zUnfoldGroup();
			bool	zGroupFolded();
			
			void 	zExchangeChilds(ZGroup *g1, ZGroup *g2);
			void 	zExchangeChilds(int i1, int i2);
			void	zAddChild(ZGroup *g, int index);
			void	zRemoveChild(ZGroup *g);
			
	virtual	void	zHide();
	virtual	void	zShow();
	virtual void	zFocusChanged(bool state);

// Important pointers

			ZGroup	*zParent();
			ZView   *zView();
			ZWindow *zWindow();
			BList   *zChilds();		
			BRect	zFrame();
			void	zFrame(BRect rect);	

protected:

	friend 	class	ZWindow;
	friend	class	ZView; 
	friend	class	ZPager; 

			void	zRenderFull(ZView *view, ZWindow *window);
			void	zRenderResize();

	virtual	void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void	zRenderPass0(ZView *view, ZWindow *window, ZGroup *parent);
			
	virtual	BPoint	zRenderPass1();
	virtual BPoint	zRenderPass2();
			void	zRenderPass3();
			void	zRenderPass4(BPoint top);
	virtual	void	zRenderPass5(BRect rect);

			void	zMarkGroup();
			void	zUnmarkGroup();

			void 	zDrawBevel(BRect rect, char highpen, char lowpen);	
			BRect 	zGetInner(BRect outer);
			void 	zInstallMessageHandler();
			BRect 	zCutBorder(BRect rect);

private:
			ZGroup  *zFindHit(BPoint pos);			
			ZGroup  *zFindDragHit(BPoint pos);
			void	zDrawBorder(BRect rect);
			void	zDrawRect(BRect rect, char color);
	static	void	zMessageManager(ZGroup *obj);
			void	ZGroupConstructor(struct TagItem *tags);


			BPoint	 group_tagmax;
			BPoint	 group_tagmin;
			BPoint	 group_minsize;
			BPoint	 group_maxsize;
			char	 group_type;
			char	 group_frame;
			char	 group_framestate;
			BRect	 group_border;
			ZView   *group_view;
			BPoint	 group_weight;
			BRect	 group_update;
			char	 group_align;
			ZWindow *group_window;
			char	 group_state;
			char	 group_pen;
			bool	 group_candrag;
		BMessage    *group_dragmsg;
			ZGroup 	*group_parent;
			ZGroup	*group_target;
			char	 group_label[128];
			float	 group_labelwidth;
			float	 group_midskip;
			ZGroup  *group_windrose[4];
			bool	 group_focus;
			float	 group_space;
			BRect	 group_rect;
			BList	*group_childs;
			bool	 group_setupdone;
			int		 group_colums;
			bool	 group_folded;
			bool	 group_canrev;
			bool	 group_candrop;
			BList	*group_messagequeue;
			sem_id	 group_messagesem;
		thread_id	 group_messagethread;
			char	 group_id[ZONIC_LABEL_LENGTH];
			bool	 group_marked;
			pattern	 group_pattern;
			BRect	 group_specialclip;
};

#pragma export off

inline ZGroup  *HGroupObject(TAG_ARG)					{ return(new ZGroup(ZGroup_Type, ZGroup_Type_Horizontal,TAG_MORE,TAG_SRC)); }
inline ZGroup  *VGroupObject(TAG_ARG)					{ return(new ZGroup(ZGroup_Type, ZGroup_Type_Vertical,TAG_MORE,TAG_SRC)); }

inline char    *ZGroup::zID()							{ return group_id; }
inline ZGroup  *ZGroup::zParent()						{ return group_parent; }
inline BRect 	ZGroup::zGetInner(BRect outer)			{ return(BRect(outer.left+1,outer.top+1,outer.right-1,outer.bottom-1));	}
inline BRect 	ZGroup::zBorder()						{ return group_border;	}											
inline bool		ZGroup::zIsFocus()						{ return group_focus; }
inline ZView   *ZGroup::zView()							{ return group_view; };
inline ZWindow *ZGroup::zWindow()						{ return group_window; };
inline char		ZGroup::zFrameState()					{ return group_framestate; };
inline char		ZGroup::zState()						{ return group_state; };
inline char		ZGroup::zBackground()					{ return group_pen; };
inline ZGroup  *ZGroup::zWindrose(int i)				{ return group_windrose[i]; };
inline char		ZGroup::zFrameType()					{ return group_frame; }
inline BRect	ZGroup::zFrame()						{ return group_rect; }
inline void		ZGroup::zFrame(BRect rect)				{ group_rect=rect; }
inline char		ZGroup::zType()							{ return group_type; }
inline BPoint	ZGroup::zTagMinSize()					{ return group_tagmin; }
inline BPoint	ZGroup::zTagMaxSize()					{ return group_tagmax; }
inline BList   *ZGroup::zChilds()						{ return group_childs; }
inline bool   	ZGroup::zGroupFolded()					{ return group_folded; }
inline float   	ZGroup::zSpace()						{ return group_space; }
inline ZGroup  *ZGroup::zTarget()						{ return group_target; }
inline void		ZGroup::zSetTagMinSize(BPoint rect)		{ group_tagmin=rect; }
inline void		ZGroup::zSetTagMaxSize(BPoint rect)		{ group_tagmax=rect; }
inline BPoint	ZGroup::zMinSize()						{ return group_minsize; }
inline BPoint	ZGroup::zMaxSize()						{ return group_maxsize; }
inline void		ZGroup::zSetID(char *id)				{ strcpy(group_id,id); }
inline void		ZGroup::zSetType(char type)				{ group_type=type; }
inline void		ZGroup::zSetFrameType(char type)		{ group_frame=type; }
inline void		ZGroup::zSetBorder(BRect rect)			{ group_border=rect; };
inline void		ZGroup::zSetFocus(bool state)			{ group_focus=state; zFocusChanged(state); }
inline void		ZGroup::zSetDragMessage(BMessage *msg) 	{ if(group_dragmsg)delete group_dragmsg; group_dragmsg=msg; }
inline void		ZGroup::zSetState(char state)			{ group_state=state; };
inline void		ZGroup::zSetFrameState(char state)		{ group_framestate=state; };
inline void		ZGroup::zSetSpace(float s)				{ group_space=s; };
inline void		ZGroup::zSetPen(char pen)				{ group_pen=pen; };
inline void		ZGroup::zSetAlign(char align)			{ group_align=align; };
inline void		ZGroup::zSetTarget(ZGroup *g)			{ group_target=g; }
inline BPoint 	ZGroup::zSetMaxSize(BPoint dim)			{ return group_maxsize=dim; };
inline BPoint 	ZGroup::zSetMinSize(BPoint dim)			{ return group_minsize=dim; };
inline void		ZGroup::zSetWindrose(ZGroup *up, ZGroup *down, ZGroup *left, ZGroup *right)
{
	group_windrose[0]=up;
	group_windrose[1]=down;
	group_windrose[2]=left;
	group_windrose[3]=right;
}

#endif