/*
	Zonic System V0.21 alpha
	
	1996 by Tinic Urou. The alpha versions are FREEWARE.

 _________________________________________________________	
|	Interface Kit connections
|_________________________________________________________
*/
#ifndef ZINTERFACE
#define ZINTERFACE

#include "zgroup.h"

/*
	ZBButton
*/

#define	ZBBUTTON_VERSION			3

#define ZBButtonObject				new ZBButton

#define ZBButton_Label				0x1000
#define ZBButton_Message			0x1001
#define ZBButton_Value				0x1002
#define ZBButton_TargetHandler		0x1003
#define ZBButton_Enabled			0x1004
#define ZBButton_PopUp				0x1005

#pragma export on

class ZBButton : public ZGroup, public BButton
{
	public:	
					ZBButton(TAG_ARG);
					ZBButton(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zShow();
			void	zHide();
	
	private:
			char	label[128];
			BRect	oldfrm;
			void	ZBButtonConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZBCheckBox
*/

#define	ZBCHECKBOX_VERSION			2

#define ZBCheckBoxObject			new ZBCheckBox

#define ZBCheckBox_Label			0x1010
#define ZBCheckBox_Message			0x1011
#define ZBCheckBox_Value			0x1012
#define ZBCheckBox_TargetHandler	0x1013
#define ZBCheckBox_Enabled			0x1014

#pragma export on

class ZBCheckBox : public ZGroup, public BCheckBox
{
	public:	
					ZBCheckBox(TAG_ARG);
					ZBCheckBox(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zShow();
			void	zHide();
	
	private:
			char	label[128];
			BRect	oldfrm;
			void	ZBCheckBoxConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZBTextView
*/

#define	ZBTEXTVIEW_VERSION			2

#define ZBTextViewObject			new ZBTextView

#define ZBTextView_Label			0x1020
#define ZBTextView_Message			0x1021
#define ZBTextView_WordWrap			0x1022
#define ZBTextView_AutoIndent		0x1023
#define ZBTextView_Editable			0x1024

#pragma export on

class ZBTextView : public ZGroup, public BTextView
{
	public:	
					ZBTextView(TAG_ARG);
					ZBTextView(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zShow();
			void	zHide();
	
	private:
			bool	wrap;
			bool	indent;
			bool	editable;
			BRect	oldfrm;
			void	ZBTextViewConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZBStringView
*/

#define	ZBSTRINGVIEW_VERSION		2

#define ZBStringViewObject			new ZBStringView

#define ZBStringView_Text			0x1030
#define ZBStringView_Alignment		0x1031

#pragma export on

class ZBStringView : public ZGroup, public BStringView
{
	public:	
					ZBStringView(TAG_ARG);
					ZBStringView(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zShow();
			void	zHide();

	private:
			BRect	oldfrm;
			void	ZBStringViewConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZStringEdit
*/

#define	ZSTRINGEDIT_VERSION			2

#define ZStringEditObject			new ZStringEdit

#define ZStringEdit_Message			0x1040
#define ZStringEdit_Text			0x1041

#pragma export on

class ZStringEdit : public ZGroup, public BTextControl
{
	public:	
					ZStringEdit(TAG_ARG);
					ZStringEdit(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zShow();
			void	zHide();
	
	private:
			BRect	oldfrm;
			void	ZStringEditConstructor(struct TagItem *tags);
};

/*
	ZBBitmap
*/

#define	ZBBITMAP_VERSION			1

#define ZBBitmapObject			new ZBBitmap

#define ZBBitmap_Depth			0x1050
#define ZBBitmap_Bits			0x1051
#define ZBBitmap_Data			0x1051
#define ZBBitmap_Length			0x1052
#define ZBBitmap_Offset			0x1053
#define ZBBitmap_BitsDepth		0x1054
#define ZBBitmap_DataDepth		0x1055
#define ZBBitmap_Left			0x1056
#define ZBBitmap_Top			0x1057
#define ZBBitmap_Right			0x1058
#define ZBBitmap_Bottom			0x1059
#define ZBBitmap_FreeSize		0x1060

#pragma export on

class ZBBitmap : public ZGroup, public BBitmap
{
	public:	
					ZBBitmap(TAG_ARG);
					ZBBitmap(struct TagItem *tags);
			void 	zDraw(BRect rect);
	private:
			void	ZBBitmapConstructor(struct TagItem *tags);
};


#pragma export off

/*
	ZBScrollBar
*/

#define	ZBSCROLLBAR_VERSION			1

#define ZBScrollBarObject				new ZBScrollBar

#define ZBScrollBar_Target			0x1060
#define ZBScrollBar_Min				0x1061
#define ZBScrollBar_Max				0x1062
#define ZBScrollBar_Orientation		0x1063

#pragma export on

class ZBScrollBar : public ZGroup, public BScrollBar
{
	public:	
					ZBScrollBar(TAG_ARG);
					ZBScrollBar(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zShow();
			void	zHide();
	
	private:
			void	ZBScrollBarConstructor(struct TagItem *tags);
			BRect	oldfrm;
};

#pragma export off

/*
	ZBRadioButton
*/

#define	ZBRADIOBUTTON_VERSION		1

#define ZBRadioButtonObject			new ZBRadioButton

#define ZBRadioButton_Label			0x1070
#define ZBRadioButton_Message		0x1071
#define ZBRadioButton_Value			0x1072
#define ZBRadioButton_TargetHandler	0x1073
#define ZBRadioButton_Enabled		0x1014

#pragma export on

class ZBRadioButton : public ZGroup, public BRadioButton
{
	public:	
					ZBRadioButton(TAG_ARG);
					ZBRadioButton(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zShow();
			void	zHide();
	
	private:
			char	label[128];
			BRect	oldfrm;
			void	ZBRadioButtonConstructor(struct TagItem *tags);
};

#pragma export off


/*
	ZBRadioButton
*/

#define	ZBRADIOAREA_VERSION		1

#define ZBRadioAreaObject			new ZBRadioArea

#pragma export on

class ZBRadioArea : public ZGroup, public BView
{
	public:	
					ZBRadioArea(TAG_ARG);
					ZBRadioArea(struct TagItem *tags);
					
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			void	zDraw(BRect rect);
			void	zShow();
			void	zHide();
	
	private:
			BRect	oldfrm;
			void	ZBRadioAreaConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZBMenu
*/

#define	ZBMENU_VERSION		1

#define ZBMenuObject		new ZBMenu

#define ZBMenu_Title		0x1080
#define	ZBMenu_Menu			0x1081
#define ZBMenu_Item			0x1082
#define ZBMenu_Seperator	0x1083

#pragma export on

class ZBMenu : public BMenu
{
	public:	
					ZBMenu(TAG_ARG);
					ZBMenu(struct TagItem *tags);
					~ZBMenu();
	private:
			void	ZBMenuConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZBMenuItem
*/

#define	ZBMENUITEM_VERSION		1

#define ZBMenuItemObject		new ZBMenuItem

#define ZBMenuItem_Label		0x1090
#define	ZBMenuItem_Message		0x1091

#pragma export on

class ZBMenuItem : public BMenuItem
{
	public:	
					ZBMenuItem(TAG_ARG);
					ZBMenuItem(struct TagItem *tags);
					~ZBMenuItem();
	private:
			void	ZBMenuItemConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZBPopUpMenu
*/

#define	ZBPOPUPMENU_VERSION		1

#define ZBPopUpMenuObject		new ZBPopUpMenu

#define ZBPopUpMenu_Title		0x10A0
#define ZBPopUpMenu_RadioMode	0x10A1
#define ZBPopUpMenu_AutoMode	0x10A2
#define ZBPopUpMenu_Menu		0x10A3
#define ZBPopUpMenu_Item		0x10A4
#define ZBPopUpMenu_Seperator	0x10A5

#pragma export on

class ZBPopUpMenu : public BPopUpMenu
{
	public:	
					ZBPopUpMenu(TAG_ARG);
					ZBPopUpMenu(struct TagItem *tags);
					~ZBPopUpMenu();
	private:
			void	ZBPopUpMenuConstructor(struct TagItem *tags);
};

#pragma export off

/*
	ZBMenuBar
*/

#define	ZBMENUBAR_VERSION		1

#define ZBMenuBarObject			new ZBMenuBar

#define ZBMenuBar_Label			0x10B0
#define ZBMenuBar_ResizingMode	0x10B1
#define ZBMenuBar_Menu			0x10B2

#pragma export on

class ZBMenuBar : public ZGroup, public BMenuBar
{
	public:	
					ZBMenuBar(TAG_ARG);
					ZBMenuBar(struct TagItem *tags);
					~ZBMenuBar();
			void	zRenderInterfaceSetup(ZView *view, ZWindow *window);
			void 	zRenderPass5(BRect rect);
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zShow();
			void	zHide();

	private:
			void	ZBMenuBarConstructor(struct TagItem *tags);
};

#pragma export off

#endif