/*
	Zonic System V0.21 alpha
	
	1996 by Tinic Urou. The alpha versions are FREEWARE.
	
 _________________________________________________________	
|	General definitions for all Zonic Classes
|   Most of these will be placed in preferences later
|_________________________________________________________
*/
#ifndef	ZONIC
#define ZONIC

#define ZONIC_VERSION				21

#define ZONIC_MODE					B_COLOR_8_BIT
#define ZONIC_LABEL_LENGTH			200
#define ZONIC_ALLOWED_ITERATIONS	256

#define GROUP_SPACE					6.0
#define GROUP_BORDER_NORMAL			8.0
#define GROUP_BORDER_NONE			0.0

#define GROUP_NORMAL_FONT			"Emily"
#define GROUP_NORMAL_HEIGHT			10.0
#define GROUP_FIXED_FONT			"Kate"
#define GROUP_FIXED_HEIGHT			10.0
#define GROUP_TITLE_FONT			"Erich"
#define GROUP_TITLE_HEIGHT			9.0
#define GROUP_TITLE_WIDTH			4.0

#define	GROUP_DRAG_TIMEWAIT			20
#define GROUP_MAX_WIDTH				2000.0
#define GROUP_MAX_HEIGHT			2000.0

#define SYMBOL_HEIGHT				16
#define SYMBOL_WIDTH				16
#define SCROLLBAR_MIN				16

#define BG_COL						200,200,200,255
#define HALFDARK					166,166,166,255
#define DARK						  0,  0,  0,255
#define TEXTCOLOR					  0,  0,  0,255
#define HALFSHINE					222,222,222,255
#define SHINE						255,255,255,255
#define BACKGROUND					200,200,200,255
#define MARK						192, 80, 64,255
#define UNMARK						 80, 80,192,255
#define BG_ROOT						160,160,160,255
#define BG_MID						180,180,180,255
#define BG_HIGH						200,200,200,255

/*
	Special Tags
*/

#define Zonic_Dummy					0x0000
#define Zonic_Cut					0x0000
#define	Zonic_Skip					0x0001

/*
	declarations for list creation
*/

#define End							TAG_DONE,0,0

/*
	some tagstuff
*/

#define TAG_TYPE	 int
#define TAG_END		(int)0
#define	TAG_DONE	(int)0
#define TAG_SKIP	(int)1
#define TAG_MORE	(int)2

#pragma export on

struct TagItem		*FindTagItem(struct TagItem *tags, TAG_TYPE TagID );
int		 			GetTagData (struct TagItem *tags, int defval, int TagID );

#pragma export off

struct TagItem
{
	TAG_TYPE		TagID;
	TAG_TYPE		TagData;
};

#define TAG_ARG		int zzz_tags, ...
#define TAG_SRC		(struct TagItem *)&zzz_tags
#define TAG_SUPER	(struct TagItem *)&zzz_tags

/*
	class predefinition
*/

class ZButton;
class ZView;
class ZWindow;
class ZGroup;

/*
	misc prototypes
*/

void 	DrawTiled(BBitmap *bitmap, BRect into, BRect cut, BView *view);
int		ZonicLibVersion();
void 	ShowMessage(char *msg);

/*
	our bitmaps for the patterns
*/

extern BBitmap	*zRoot_Pattern;
extern BBitmap	*zMid_Pattern;
extern BBitmap	*zHigh_Pattern;

/*
	useful macros
*/

#define	MIN(a,b)	(a<b?a:b)
#define MAX(a,b)	(a>b?a:b)

#endif
