/*
	Zonic System V0.20 alpha
	
	1996 by Tinic Urou. The alpha versions are FREEWARE.
	
 _________________________________________________________	
|	A simple button with a textlabel
|_________________________________________________________
*/
#ifndef ZSLIDER
#define ZSLIDER
#include "zonic.h"
#include "zgroup.h"

#define	ZSLIDER_VERSION				3

#define ZSliderObject				new ZSlider

#define ZSlider_MessageUp			0x0060
#define ZSlider_MessageDown			0x0061
#define ZSlider_RealValue			0x0062
#define ZSlider_ViewedValue			0x0063
#define ZSlider_Position			0x0064
#define ZSlider_Page				0x0065

#pragma export on

class ZSlider : public ZGroup
{
	public:
					ZSlider(TAG_ARG);
					ZSlider(struct TagItem *tags);
					
			BPoint	zRenderPass1();				
			BPoint	zRenderPass2();		
			void	zDraw(BRect rect);
			void	zDrawPart();
			bool	zMouseDown(BPoint pos);

			void	zSetReal(float r);
			void	zSetViewed(float r);
			bool	zSetPosition(float r);
			void	zSetPage(float r);
			void	zSetMessageDown(BMessage *msg);
			void	zSetMessageUp(BMessage *msg);
			float	zReal();
			float	zViewed();
			float	zPosition();
			float	zPage();
		BMessage 	*zMessageUp();
		BMessage 	*zMessageDown();
	
	private:
	
	friend	class	ZScrollBar;
	
			float	real;
			float	viewed;
			float	position;
			float	page;

		BMessage	*msgup;
		BMessage	*msgdown;
			BRect	knob;

			void	ZSliderConstructor(struct TagItem *tags);
};

#pragma export off

inline	void	ZSlider::zSetMessageUp(BMessage *msg)	{ msgup=msg; };
inline	void	ZSlider::zSetMessageDown(BMessage *msg)	{ msgdown=msg; };
inline	void	ZSlider::zSetReal(float r)				{ real=r; };
inline	void	ZSlider::zSetViewed(float r)			{ viewed=r; };
inline	void	ZSlider::zSetPage(float r)				{ page=r; };
inline	BMessage *ZSlider::zMessageDown()				{ return msgdown; };
inline	BMessage *ZSlider::zMessageUp()					{ return msgup; };
inline	float	ZSlider::zReal()						{ return real; };
inline	float	ZSlider::zViewed()						{ return viewed; };
inline	float	ZSlider::zPosition()					{ return position; };
inline	float	ZSlider::zPage()						{ return page; };

#endif
