/*
	Zonic System V0.21 alpha
	
	1996 by Tinic Urou. The alpha versions are FREEWARE.

 _________________________________________________________	
|	Adopted Window and View for Zonic
|_________________________________________________________
*/
#ifndef ZWINDOW
#define ZWINDOW

#define ZWINDOW_VERSION				8

#include "zonic.h"
#include "zgroup.h"

#define ZWindowObject				new ZWindow

#define	ZWindow_Name				0xF002
#define	ZWindow_Type				0xF003
#define	ZWindow_Flags				0xF004
#define	ZWindow_Workspaces			0xF005
#define ZWindow_View				0xF006
#define ZWindow_Left				0xF007
#define ZWindow_Top					0xF008
#define ZWindow_Right				0xF009
#define ZWindow_Bottom				0xF00A
#define	ZWindow_FixSize				0xF00B

#define ZView_Name					0xF080
#define ZView_Flags					0xF081
#define ZView_Contents				0xF082
#define ZView_RootPattern			0xF083
#define ZView_MidPattern			0xF084
#define ZView_HighPattern			0xF085
#define ZView_Background			0xF086

#pragma export on

class ZView : public BView
{
	public:			
					ZView(TAG_ARG);
					ZView(struct TagItem *tags);

	private:

	friend	class	ZPager;
	friend	class	ZGroup;
	friend	class	ZWindow;

			void	MessageReceived(BMessage *message);
			void	Draw(BRect rect);
			void	MouseDown(BPoint pos);
			void 	MouseMoved(BPoint point, ulong transit, BMessage *message);
			void 	FrameResized(float new_width, float new_height);
			void	KeyDown(ulong aKey);
			void 	AttachedToWindow();
			ZGroup 	*contents;

			ZGroup	*zFocusGroup;
			BList	*zFocusCycle;
			int		zFocusPos;
			void	zFocusNext();
			void	zFocusPrev();
			void	zMakeFocus(ZGroup *group);
			void	zInitFocus(BList *objects);
			void 	zExchangeGroups(ZGroup *g1, ZGroup *g2);
			
			BBitmap	*zRoot_Pattern;
			BBitmap	*zMid_Pattern;
			BBitmap	*zHigh_Pattern;
			
			void	ZViewConstructor(struct TagItem *tags);
			
			ZGroup	*group_marked;
};

class ZWindow : public BWindow
{
	public:
					ZWindow(TAG_ARG);
					ZWindow(struct TagItem *tags);
					
	virtual	bool	QuitRequested();
	
	private:
	
	friend	class	ZView;
	
			void 	FrameResized(float width, float height);
			ZView	*zView;
};

#pragma export off

#endif