/*
	Zonic System V0.21 alpha
	
	1996 by Tinic Urou. Distribution of this
	sources is strictly prohibited.

 _________________________________________________________	
|	A scrollbar which is combined of three other objects
|_________________________________________________________
*/
#include "zscrollbar.h"

#define SCROLLBAR_MSGDOWN		'scdw'
#define SCROLLBAR_MSGUP			'scup'
#define SCROLLBAR_MSGARRDOWN	'sadw'
#define SCROLLBAR_MSGARRUP		'saup'

ZScrollBar::ZScrollBar(TAG_ARG):ZGroup(TAG_SRC) {	ZScrollBarConstructor(TAG_SRC); }
ZScrollBar::ZScrollBar(struct TagItem *tags):ZGroup(tags) { ZScrollBarConstructor(tags); }

void ZScrollBar::ZScrollBarConstructor(struct TagItem *tags)
{
	zSetFrameType((char)GetTagData(tags,ZGroup_Frame_None,ZGroup_Frame));
	zSetSpace((float)GetTagData(tags,1,ZGroup_Space));
	msgup=(BMessage *)GetTagData(tags,NULL,ZScrollBar_MessageUp);
	msgdown=(BMessage *)GetTagData(tags,NULL,ZScrollBar_MessageDown);
	step=(int)GetTagData(tags,1,ZScrollBar_Step);

	zInstallMessageHandler();
	
	zChilds()->AddItem
	(
		s2 = new ZSymbol
		(
			ZSymbol_Symbol,			zType()==ZGroup_Type_Vertical ? ZSymbol_Symbol_ArrowDown : ZSymbol_Symbol_ArrowRight,
			ZSymbol_MessageDown,	new BMessage(SCROLLBAR_MSGARRDOWN),
			End
		),
		0
	);
	zChilds()->AddItem
	(
		s1 = new ZSymbol
		(
			ZSymbol_Symbol,			zType()==ZGroup_Type_Vertical ? ZSymbol_Symbol_ArrowUp : ZSymbol_Symbol_ArrowLeft,
			ZSymbol_MessageDown,	new BMessage(SCROLLBAR_MSGARRUP),
			End
		),
		0
	);
	zChilds()->AddItem
	(
		s3 = new ZSlider
		(
			ZGroup_Type, 			zType(),
			ZSlider_MessageUp,		new BMessage(SCROLLBAR_MSGUP),
			ZSlider_MessageDown,	new BMessage(SCROLLBAR_MSGDOWN),
			ZSlider_RealValue,		(int)GetTagData(tags,100,ZScrollBar_RealValue),
			ZSlider_ViewedValue,	(int)GetTagData(tags, 25,ZScrollBar_ViewedValue),
			ZSlider_Position,		(int)GetTagData(tags,  0,ZScrollBar_Position),
			ZSlider_Page,			(int)GetTagData(tags, 25,ZScrollBar_Page),				
			End
		),
		0
	);
	s1->zSetTarget(this);
	s2->zSetTarget(this);
	s3->zSetTarget(this);
}

void ZScrollBar::zMessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case	SCROLLBAR_MSGARRDOWN:
				s3->zSetPosition(s3->zPosition()+step);
				if(msgup)zPostMessage(new BMessage(msgup));
				break;
		case	SCROLLBAR_MSGARRUP:
				s3->zSetPosition(s3->zPosition()-step);
				if(msgup)zPostMessage(new BMessage(msgup));
				break;
		case	SCROLLBAR_MSGUP:
				if(msgup)zPostMessage(new BMessage(msgup));
				break;
		case	SCROLLBAR_MSGDOWN:
				if(msgdown)zPostMessage(new BMessage(msgdown));
				break;
	}
}

bool ZScrollBar::zMessageFilter(BMessage *msg)
{
	switch(msg->what)
	{
		case	SCROLLBAR_MSGARRDOWN:
		case	SCROLLBAR_MSGARRUP:
		case	SCROLLBAR_MSGUP:
		case	SCROLLBAR_MSGDOWN:
				return TRUE;
		default:
				return FALSE;
	}
};
